/**
 *  Este programa é software livre; você pode redistribuí-lo e/ou
 *  modificá-lo sob os termos da Licença Pública Geral GNU, conforme
 *  publicada pela Free Software Foundation; tanto a versão 2 da
 *  Licença como (a seu critério) qualquer versão mais nova.
 *
 *  Este programa é distribuído na expectativa de ser útil, mas SEM
 *  QUALQUER GARANTIA; sem mesmo a garantia implícita de
 *  COMERCIALIZAÇÃO ou de ADEQUAÇÃO A QUALQUER PROPÓSITO EM
 *  PARTICULAR. Consulte a Licença Pública Geral GNU para obter mais
 *  detalhes.
 *
 *  Você deve ter recebido uma cópia da Licença Pública Geral GNU
 *  junto com este programa; se não, escreva para a Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *  02111-1307, USA.
 * 
 *  Prof. Emerson Ribeiro de Mello (2011)
 *  mello@ifsc.edu.br
 */

/*
 * JavaBomberPrincipal.java
 *
 * Created on 25/10/2011, 14:25:56
 */
package principal;

import java.awt.BorderLayout;
import jogo.Controles;
import jogo.Instrucoes;
import jogo.JogoTimer;
import jogo.Sobre;

/**
 *
 * @author Emerson Ribeiro de Mello
 */
public class JavaBomber extends javax.swing.JFrame {

    private JogoTimer jogo;
    public Teclado teclado;
    public boolean jogoRodando;
    public boolean jogoPausado;
    private int acao;
    public boolean jogoEncerrado;
    Controles janelaControle = new Controles(this, true);

    /** Creates new form JavaBomberPrincipal */
    // construtor da classe JavaBomber, classe principal do jogo
    public JavaBomber() {
        initComponents();
        this.setLocationRelativeTo(null);
        this.jogo = new JogoTimer(this);
        jogo.setSize(jPTelaPrincipal.getSize());
        jogo.setPreferredSize(jPTelaPrincipal.getSize());
        jPTelaPrincipal.add(jogo, BorderLayout.PAGE_START);
        teclado = new Teclado();
        this.jPTelaPrincipal.addKeyListener(teclado);
        this.jogo.addKeyListener(teclado);
        this.jogoRodando = false;
        jButtonReiniciar.setEnabled(false);
        // dando foco no botao
        this.jButtonIniciar.requestFocus();

    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPInformacoes = new javax.swing.JPanel();
        jButtonIniciar = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jLIconeJ2 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jLabelVida1P2 = new javax.swing.JLabel();
        jLabelVida2P2 = new javax.swing.JLabel();
        jLabelVida3P2 = new javax.swing.JLabel();
        jLabelVitoriasP2 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jLIconeJ1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabelVida2P1 = new javax.swing.JLabel();
        jLabelVida3P1 = new javax.swing.JLabel();
        jLabelVida1P1 = new javax.swing.JLabel();
        jLabelVitoriasP1 = new javax.swing.JLabel();
        jButtonReiniciar = new javax.swing.JButton();
        jPTelaPrincipal = new javax.swing.JPanel();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenuJogo = new javax.swing.JMenu();
        jMenuIniciar = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JPopupMenu.Separator();
        jMenuNovoJogo = new javax.swing.JMenuItem();
        jSeparator3 = new javax.swing.JPopupMenu.Separator();
        jMenuSair = new javax.swing.JMenuItem();
        jMenuConfiguracoes = new javax.swing.JMenu();
        jMenuIntemControles = new javax.swing.JMenuItem();
        jMenuAjuda = new javax.swing.JMenu();
        jMenuInstrucoes = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JPopupMenu.Separator();
        jMenuSobre = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("JavaBomber");
        setResizable(false);
        addWindowFocusListener(new java.awt.event.WindowFocusListener() {
            public void windowGainedFocus(java.awt.event.WindowEvent evt) {
                formWindowGainedFocus(evt);
            }
            public void windowLostFocus(java.awt.event.WindowEvent evt) {
            }
        });

        jButtonIniciar.setText("Iniciar");
        jButtonIniciar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonIniciarActionPerformed(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Jogador 2"));

        jLIconeJ2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/vermelho.png"))); // NOI18N

        jLabel1.setText("Vidas:");

        jLabelVida1P2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/vermelho.png"))); // NOI18N

        jLabelVida2P2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/vermelho.png"))); // NOI18N

        jLabelVida3P2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/vermelho.png"))); // NOI18N

        jLabelVitoriasP2.setText("Vitórias: 0");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel1)
                    .addComponent(jLIconeJ2, javax.swing.GroupLayout.PREFERRED_SIZE, 91, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabelVida1P2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelVida2P2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelVida3P2)
                        .addContainerGap(76, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelVitoriasP2)
                        .addGap(45, 45, 45))))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabelVida2P2)
                    .addComponent(jLabelVida1P2)
                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                            .addComponent(jLabelVitoriasP2)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabelVida3P2))
                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                            .addComponent(jLIconeJ2, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(jLabel1))))
                .addContainerGap(61, Short.MAX_VALUE))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Jogador 1"));

        jLIconeJ1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/azul.png"))); // NOI18N

        jLabel2.setText("Vidas:");

        jLabelVida2P1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/azul.png"))); // NOI18N

        jLabelVida3P1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/azul.png"))); // NOI18N

        jLabelVida1P1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/azul.png"))); // NOI18N

        jLabelVitoriasP1.setText("Vitórias: 0");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel2)
                    .addComponent(jLIconeJ1, javax.swing.GroupLayout.PREFERRED_SIZE, 91, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGap(11, 11, 11)
                        .addComponent(jLabelVida1P1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabelVida2P1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelVida3P1, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap(63, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelVitoriasP1)
                        .addGap(48, 48, 48))))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(jLIconeJ1, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel2)
                .addContainerGap(61, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addComponent(jLabelVitoriasP1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 47, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabelVida3P1)
                    .addComponent(jLabelVida2P1)
                    .addComponent(jLabelVida1P1))
                .addGap(47, 47, 47))
        );

        jButtonReiniciar.setText("Reiniciar");
        jButtonReiniciar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonReiniciarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPInformacoesLayout = new javax.swing.GroupLayout(jPInformacoes);
        jPInformacoes.setLayout(jPInformacoesLayout);
        jPInformacoesLayout.setHorizontalGroup(
            jPInformacoesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPInformacoesLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPInformacoesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPInformacoesLayout.createSequentialGroup()
                        .addGap(8, 8, 8)
                        .addComponent(jButtonIniciar, javax.swing.GroupLayout.DEFAULT_SIZE, 157, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButtonReiniciar, javax.swing.GroupLayout.PREFERRED_SIZE, 156, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPInformacoesLayout.setVerticalGroup(
            jPInformacoesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPInformacoesLayout.createSequentialGroup()
                .addGroup(jPInformacoesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonIniciar, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButtonReiniciar, javax.swing.GroupLayout.DEFAULT_SIZE, 31, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPTelaPrincipal.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jPTelaPrincipalMouseClicked(evt);
            }
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                jPTelaPrincipalMouseEntered(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jPTelaPrincipalMousePressed(evt);
            }
        });
        jPTelaPrincipal.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                jPTelaPrincipalFocusLost(evt);
            }
        });
        jPTelaPrincipal.setLayout(new java.awt.BorderLayout());

        jMenuJogo.setMnemonic('J');
        jMenuJogo.setText("Jogo");

        jMenuIniciar.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Q, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.SHIFT_MASK));
        jMenuIniciar.setMnemonic('I');
        jMenuIniciar.setText("Iniciar Jogo");
        jMenuIniciar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuIniciarActionPerformed(evt);
            }
        });
        jMenuJogo.add(jMenuIniciar);
        jMenuJogo.add(jSeparator1);

        jMenuNovoJogo.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_A, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.SHIFT_MASK));
        jMenuNovoJogo.setMnemonic('N');
        jMenuNovoJogo.setText("Novo jogo");
        jMenuNovoJogo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuNovoJogoActionPerformed(evt);
            }
        });
        jMenuJogo.add(jMenuNovoJogo);
        jMenuJogo.add(jSeparator3);

        jMenuSair.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Z, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.SHIFT_MASK));
        jMenuSair.setMnemonic('S');
        jMenuSair.setText("Sair");
        jMenuSair.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuSairActionPerformed(evt);
            }
        });
        jMenuJogo.add(jMenuSair);

        jMenuBar1.add(jMenuJogo);

        jMenuConfiguracoes.setMnemonic('C');
        jMenuConfiguracoes.setText("Configurações");

        jMenuIntemControles.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_E, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.SHIFT_MASK));
        jMenuIntemControles.setMnemonic('o');
        jMenuIntemControles.setText("Controles");
        jMenuIntemControles.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuIntemControlesActionPerformed(evt);
            }
        });
        jMenuConfiguracoes.add(jMenuIntemControles);

        jMenuBar1.add(jMenuConfiguracoes);

        jMenuAjuda.setMnemonic('A');
        jMenuAjuda.setText("Ajuda");
        jMenuAjuda.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuAjudaActionPerformed(evt);
            }
        });

        jMenuInstrucoes.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_W, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.SHIFT_MASK));
        jMenuInstrucoes.setMnemonic('I');
        jMenuInstrucoes.setText("Instruções");
        jMenuInstrucoes.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuInstrucoesActionPerformed(evt);
            }
        });
        jMenuAjuda.add(jMenuInstrucoes);
        jMenuAjuda.add(jSeparator2);

        jMenuSobre.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.SHIFT_MASK));
        jMenuSobre.setMnemonic('S');
        jMenuSobre.setText("Sobre");
        jMenuSobre.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuSobreActionPerformed(evt);
            }
        });
        jMenuAjuda.add(jMenuSobre);

        jMenuBar1.add(jMenuAjuda);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPTelaPrincipal, javax.swing.GroupLayout.PREFERRED_SIZE, 679, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPInformacoes, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPTelaPrincipal, javax.swing.GroupLayout.DEFAULT_SIZE, 395, Short.MAX_VALUE)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPInformacoes, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    
    private void jButtonIniciarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonIniciarActionPerformed
        if (this.jogoRodando == false) {
            this.jogoRodando = true;
            jButtonIniciar.setText("Pausar");
            jMenuIniciar.setText("Pausar");
            this.jogo.comecaOJogo();
            jButtonReiniciar.setEnabled(true);

        } else {
            if (this.jogoPausado == false) {
                this.jogo.pausarOJogo(this.jogoPausado);
                jButtonIniciar.setText("Sair Pausa");
                jMenuIniciar.setText("Sair Pausa");
                this.jogo.renderizar();
                this.jogo.desenhar();
                this.jogoPausado = true;
            } else {
                this.jogo.pausarOJogo(this.jogoPausado);
                this.jogoPausado = false;
                jButtonIniciar.setText("Pausar");
                jMenuIniciar.setText("Pausar");
            }
        }
        this.jPTelaPrincipal.requestFocus();
    }//GEN-LAST:event_jButtonIniciarActionPerformed

    private void formWindowGainedFocus(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowGainedFocus
        if (jogoRodando) {
            // dando foco na area do jogo
            this.jPTelaPrincipal.requestFocus();
        }
            if (this.jogoRodando == true) { // caso o jogo esteja roando, ou já rodou, redesenha a tela.
        this.jogo.desenhar();
    }
    }//GEN-LAST:event_formWindowGainedFocus

    private void jPTelaPrincipalFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jPTelaPrincipalFocusLost
        if (this.jogoRodando) {
            this.jPTelaPrincipal.requestFocus();
            this.jogo.desenhar();
        }
    }//GEN-LAST:event_jPTelaPrincipalFocusLost

private void jButtonReiniciarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonReiniciarActionPerformed
// TODO add your handling code here:
    if (this.jogoRodando == true) {
        this.jogo.reiniciaOJogo();
        jButtonIniciar.setText("Pausar");
        jMenuIniciar.setText("Pausar");
        jButtonIniciar.setEnabled(true);
        this.jogoPausado = false;
        this.jogo.comecaOJogo();
        this.jPTelaPrincipal.requestFocus();
    }
}//GEN-LAST:event_jButtonReiniciarActionPerformed

private void jMenuSairActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuSairActionPerformed
// TODO add your handling code here:
    System.exit(0);
}//GEN-LAST:event_jMenuSairActionPerformed

private void jMenuNovoJogoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuNovoJogoActionPerformed
// TODO add your handling code here:
    jButtonReiniciarActionPerformed(null);
}//GEN-LAST:event_jMenuNovoJogoActionPerformed

private void jMenuIniciarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuIniciarActionPerformed
// TODO add your handling code here:
    if (jogoEncerrado == false) {
        jButtonIniciarActionPerformed(null);
    }
    if (this.jogoRodando == true) { // caso o jogo esteja roando, ou já rodou, redesenha a tela.
        this.jogo.desenhar();
    }

}//GEN-LAST:event_jMenuIniciarActionPerformed

private void jMenuSobreActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuSobreActionPerformed
// TODO add your handling code here:
    if (this.jogoRodando == true) { // caso o jogo esteja roando, ou já rodou, redesenha a tela.
        this.jogo.desenhar();
    }
    Sobre janelaSobre = new Sobre(this, true);// cria o dialog  janelaSobre
    janelaSobre.setLocationRelativeTo(this);
    janelaSobre.setVisible(true); // deixa visível o dialog  janelaSobre
    if (this.jogoRodando == true) { // caso o jogo esteja roando, ou já rodou, redesenha a tela.
        this.jogo.desenhar();
    }
}//GEN-LAST:event_jMenuSobreActionPerformed

private void jMenuIntemControlesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuIntemControlesActionPerformed
// TODO add your handling code here:
    janelaControle.setaTexto(); // reescreve o texto da janela controles
    janelaControle.setLocationRelativeTo(this);
    if (this.jogoEncerrado == false && this.jogoRodando == true) {// só chama o pause se o jogo já rodou alguma vez, e se ainda estiver rodando
        jButtonIniciarActionPerformed(null); // pausa o jogo quando entra na aba controles
    }
    janelaControle.setVisible(true);// deixa visível o dialog  janelaControle
    if (this.jogoEncerrado == false && this.jogoRodando == true) { // só chama o pause se o jogo já rodou alguma vez, e se ainda estiver rodando
        jButtonIniciarActionPerformed(null); // despausa o jogo quando entra na aba controles
    } else {
        if (this.jogoRodando == true) { // caso o jogo esteja roando, ou já rodou, redesenha a tela.
            this.jogo.desenhar();
        }
    }
    if (this.jogoEncerrado == false && this.jogoRodando == true) { // troca as teclas em hot ( somente se o jogo estiver rodando )

        jogo.jog1.setCima(retornarTecla(1, 1));
        jogo.jog1.setBaixo(retornarTecla(1, 2));
        jogo.jog1.setDireita(retornarTecla(1, 3));
        jogo.jog1.setEsquerda(retornarTecla(1, 4));
        jogo.jog1.setAtirar(retornarTecla(1, 5));
        jogo.jog2.setCima(retornarTecla(2, 1));
        jogo.jog2.setBaixo(retornarTecla(2, 2));
        jogo.jog2.setDireita(retornarTecla(2, 3));
        jogo.jog2.setEsquerda(retornarTecla(2, 4));
        jogo.jog2.setAtirar(retornarTecla(2, 5));

    }
}//GEN-LAST:event_jMenuIntemControlesActionPerformed
    public int retornarTecla(int jogador, int tecla) { //faz a coleta de cada telcha para cada jogador
        acao = janelaControle.retornarTecla(jogador, tecla);
        return acao;

    }

private void jMenuInstrucoesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuInstrucoesActionPerformed
// TODO add your handling code here:
    Instrucoes janelaInstrucoes = new Instrucoes(this, true);// cria o dialog janelaInstrucoes
    janelaInstrucoes.setLocationRelativeTo(this);
    janelaInstrucoes.setVisible(true); // deixa visível o dialog janelaInstrucoes
    if (this.jogoRodando == true) { // caso o jogo esteja roando, ou já rodou, redesenha a tela.
        this.jogo.desenhar();
    }
}//GEN-LAST:event_jMenuInstrucoesActionPerformed

private void jMenuAjudaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuAjudaActionPerformed
// TODO add your handling code here:
    if (this.jogoRodando == true) { // caso o jogo esteja roando, ou já rodou, redesenha a tela.
        this.jogo.desenhar();
    }
}//GEN-LAST:event_jMenuAjudaActionPerformed

private void jPTelaPrincipalMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPTelaPrincipalMouseEntered
// TODO add your handling code here:
    if (this.jogoRodando == true) { // caso o jogo esteja roando, ou já rodou, redesenha a tela.
        this.jogo.desenhar();
    }
}//GEN-LAST:event_jPTelaPrincipalMouseEntered

private void jPTelaPrincipalMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPTelaPrincipalMousePressed
// TODO add your handling code here:
    if (this.jogoRodando == true) { // caso o jogo esteja roando, ou já rodou, redesenha a tela.
        this.jogo.desenhar();
    }
}//GEN-LAST:event_jPTelaPrincipalMousePressed

private void jPTelaPrincipalMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPTelaPrincipalMouseClicked
// TODO add your handling code here:
    if (this.jogoRodando == true) { // caso o jogo esteja roando, ou já rodou, redesenha a tela.
        this.jogo.desenhar();
    }
        if (this.jogoRodando == true) { // caso o jogo esteja roando, ou já rodou, redesenha a tela.
        this.jogo.desenhar();
    }
}//GEN-LAST:event_jPTelaPrincipalMouseClicked

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(JavaBomber.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(JavaBomber.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(JavaBomber.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(JavaBomber.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {

                new JavaBomber().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    public javax.swing.JButton jButtonIniciar;
    public javax.swing.JButton jButtonReiniciar;
    public javax.swing.JLabel jLIconeJ1;
    private javax.swing.JLabel jLIconeJ2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    public javax.swing.JLabel jLabelVida1P1;
    public javax.swing.JLabel jLabelVida1P2;
    public javax.swing.JLabel jLabelVida2P1;
    public javax.swing.JLabel jLabelVida2P2;
    public javax.swing.JLabel jLabelVida3P1;
    public javax.swing.JLabel jLabelVida3P2;
    public javax.swing.JLabel jLabelVitoriasP1;
    public javax.swing.JLabel jLabelVitoriasP2;
    private javax.swing.JMenu jMenuAjuda;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenu jMenuConfiguracoes;
    private javax.swing.JMenuItem jMenuIniciar;
    private javax.swing.JMenuItem jMenuInstrucoes;
    private javax.swing.JMenuItem jMenuIntemControles;
    private javax.swing.JMenu jMenuJogo;
    private javax.swing.JMenuItem jMenuNovoJogo;
    private javax.swing.JMenuItem jMenuSair;
    private javax.swing.JMenuItem jMenuSobre;
    private javax.swing.JPanel jPInformacoes;
    private javax.swing.JPanel jPTelaPrincipal;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPopupMenu.Separator jSeparator1;
    private javax.swing.JPopupMenu.Separator jSeparator2;
    private javax.swing.JPopupMenu.Separator jSeparator3;
    // End of variables declaration//GEN-END:variables
}
